const int x=160;//number of samples
int k=0,tens[x], crt[x];
float sum_p_activa_inst=1,p_activa_inst=1,sum_squared_current=1,sum_squared_voltage=1,RMS_tens=1,RMS_crt=1, Energie=0;
float U_rms=0, I_rms=0, cos_fi=0, P=0, S=0, Q=0, Q_med=0;
unsigned long timp=millis();
float squared_voltage=1,squared_current=1,P_activa=1,P_aparenta=1,factor_putere=1, Energia=0;
#include <Adafruit_GFX.h>
#include <Adafruit_PCD8544.h>
Adafruit_PCD8544 display = Adafruit_PCD8544(11, 10, 9, 7, 8);
void setup() {
  display.begin();
  display.setContrast(60);
  display.setRotation(2);  // rotate 90 degrees counter clockwise, can also use values of 2 and 3 to go further.
  display.setCursor(0,0);
}

void loop() {
  //measurements (instantaneous values)
  
  for(int i=0; i<x; i++)
  {
    tens[i]=analogRead(A0);
    crt[i]=509*2-analogRead(A1); //180 deg phase shift for the current sensor
  }

 //calculations and display
 sum_p_activa_inst=0; 
 sum_squared_voltage=0;
 sum_squared_current=0;
  for(int i=0; i<x-6; i++)
  { //here 1.37 and 0.049 are the calibration constants
     double var_tens=(tens[i]-508)*1.37; 
     double var_crt=(crt[i+6]-507)*0.049; //we delay the current to be in phase with the voltage (voltage is delayed by the transformer)
    p_activa_inst=var_tens*var_crt;
    sum_p_activa_inst+=p_activa_inst;
    squared_voltage=var_tens*var_tens;
    sum_squared_voltage +=squared_voltage;
    squared_current=var_crt*var_crt;
    sum_squared_current += squared_current;
  }
  P_activa=sum_p_activa_inst/x;
  if(abs(P_activa)<1.5) P_activa=0;
  RMS_tens=sqrt(sum_squared_voltage/x);
  if(RMS_tens<=2) RMS_tens=0;
  RMS_crt=sqrt(sum_squared_current/x);
  if(RMS_crt<=0.1) RMS_crt=0;
  P_aparenta=RMS_tens*RMS_crt;
  factor_putere=P_activa/P_aparenta;
  Q=P_aparenta*sqrt(1-factor_putere*factor_putere);
  
  k++;
  U_rms+= RMS_tens;
  I_rms+= RMS_crt;
  S+=P_aparenta;
  P+=P_activa;
  cos_fi+=factor_putere;
  Q_med+=Q;

  if(k>=10) // average of 11 measurements
  {
  U_rms/=k;
  if(U_rms<=2) U_rms=0;
  I_rms/=k;
  if(I_rms<=0.1) I_rms=0;
  S/=k;
  P/=k;
  if(abs(P)<1.5) P=0;
  cos_fi/=k; 
  Q_med/=k;
  k=0;
  Energie+=P*(millis()-timp)/3600000.0; //Wh
  timp=millis();

  display.clearDisplay();
  display.setCursor(0,0);
 
  display.print("U_rms=");
  display.print(U_rms);
  display.println(" V");
  
  display.print("I_rms=");
  display.print(I_rms);
  display.println(" A");
  
  display.print("P="); // active power
  display.print(P);
  display.println(" W");
  display.print("E=");
  display.print(Energie); //energy
  display.println(" Wh");

  display.print("Pret="); //price
  display.print(Energie/1000*0.6789);
  display.println("lei");
 
  display.print("cos_fi="); //power factor
  display.println(cos_fi);
  
  display.display();
  U_rms=0;
  I_rms=0;
  S=0;
  P=0;
  cos_fi=0; 
  Q_med=0;
  }
}
